/* 
 * read ksc5601 code and return n byte code 
 */

#include <stdio.h>
#include "hantbl.h"

#define  ENG    0
#define  KOR    1

char Cho_tbl[21] =
{ 
	0,0,65,66,68,71,72,73,81,82,83,85,86,87,88,89,90,
	91,92,93,94};
char Jung_tbl[30] =
{ 
	0,0,98,99,0,100,101,102,0,103,106,107,0,108,108,
	108,0,108,114,115,0,115,115,115,0,119,122,122,0,124};
char Jung_ant[30] = 
{ 
	0,0,0,0,0,0,0,0,0,0,0,0,0,0,98,99,0,124,
	0,0,0,102,103,124,0,0,0,124,0,0 };
char Jong_tbl[29] =
{ 
	0,0,65,66,65,68,68,68,71,73,73,73,73,73,73,73,73,81,
	82,82,85,86,87,88,90,91,92,93,94};
char Jong_ant[30] = 
{ 
	0,0, 0, 0,85, 0,88,94, 0, 0,65,81,82,85,92,93,94,
	0, 0,85, 0, 0, 0, 0, 0, 0, 0, 0, 0};

extern int h1e1;

int  C_Mode=ENG;
int mode;

char ibuf[BUFSIZ];
int iidx, ilen;


int hksread (fd, buf, siz)
int fd;
char *buf;
int siz;
{
	int i,j, cc;
	unsigned char  c1,c2;
	char               c;
	int idx;
	char s[10];

#define hgetchar(c) { if (iidx < ilen) c = ibuf[iidx++]; else read(fd, &c, 1);}
	mode = C_Mode;

	ilen = read (fd, ibuf, (siz+2)/3);
	if (ilen <= 0) return ilen;

	idx = 0; iidx = 0;
	while (iidx < ilen) {
		 hgetchar(c);
		c1 = (unsigned)c;
		if(c1&0x80)
		{  
			if(C_Mode == ENG) { 
				buf[idx++] = 14; 
			}
			C_Mode = KOR;
			i=0; 
			i= i^c1; 
			i= i<<8;
			hgetchar(c2); 
			i= i^c2;
			intoNbyte(intoCom(i), buf+idx);
			idx += strlen(buf+idx);
		}
		else 
		{  
			if(C_Mode == KOR) { 
				buf[idx++] = 15; 
			}
			C_Mode = ENG;
			{ 
				buf[idx++] = c1; 
			}
		}
	}

/*
	if (mode != C_Mode) {
	    if (mode == KOR) buf[idx++] = 15;
	    if (mode == ENG) buf[idx++] = 14;
	}
*/

        return idx;
}

int hnwrite (fd, buf, siz)
int fd;
char *buf;
int siz;
{
	int i,j, cc;
	unsigned char  c1,c2;
	char               c;
	char s[10];
	char ch;

#define hputchar(c) { ch = c; write(fd, &ch, 1); }
	mode = C_Mode;

	for ( cc = 0; cc < siz; ) {
		c=buf[cc++];
		c1 = (unsigned)c;
		if(c1&0x80)
		{  
			if(mode == ENG) hputchar(14);
			mode = KOR;
			i=0; 
			i= i^c1; 
			i= i<<8; 
			c2=buf[cc++]; 
			i= i^c2;
			intoNbyte(intoCom(i), s);
			write(fd, s, strlen(s));
			if (h1e1) {
			    hputchar(' ');
			}
		}
		else 
		{  
			if(mode == KOR) hputchar(15);
			mode = ENG;
			hputchar(c1);
		}
	}

	if (mode != C_Mode) {
	    if (mode == KOR) hputchar(15)
	    if (mode == ENG) hputchar(14)
	}

	return siz;
}



/****   Function which make KSC2S code from Hangule-Character   */
/*      Binary Search algorithm used (Assume ksc2c-ksc2s sorted)*/
int intoCom(key)
int key;
{ 
	int l,u,m,tmp;

	l=0; 
	u= KSC_SIZE -1;
	while(l<=u)
	{       
		m = (l+u)/2;
		tmp = KSC2CS[m][1];
		if(key  > tmp)  l = m+1;
		else if(key == tmp)  return(KSC2CS[m][0]);
		else if(key  < tmp)  u = m-1;
	}
	l=0; 
	u=KEY_SIZE -1;
	while(l<=u)
	{       
		m = (l+u)/2;
		tmp = KSC2S_C[m][1];
		if(key  > tmp)  l = m+1;
		else if(key == tmp)  return(KSC2S_C[m][0]);
		else if(key  < tmp)  u = m-1;
	}
	return(key);
}

intoNbyte(key, Nbyte)
int key;
char *Nbyte;
{  
	int cho,jung,jong;

	int i=0;

	cho = (key & 0x7c00) >> 10;
	jung= (key & 0x03e0) >> 5;
	jong= (key & 0x001f);

	Nbyte[i]  = Cho_tbl[cho -8];  
	if(Nbyte[i]) i++;
	Nbyte[i]  = Jung_tbl[jung];   
	if(Nbyte[i]) i++;
	if(Jung_ant[jung]) Nbyte[i++]  = Jung_ant[jung];
	Nbyte[i]  = Jong_tbl[jong];   
	if(Nbyte[i]) i++;
	if(Jong_ant[jong]) Nbyte[i++]  = Jong_ant[jong];
	Nbyte[i] = '\0';
}
